/* ************************************************************************** */
/** Descriptive File Name

  @Company
	Company Name

  @File Name
	filename.c

  @Summary
	Brief description of the file.

  @Description
	Describe the purpose of this file.
 */
/* ************************************************************************** */
/* ************************************************************************** */
/* ************************************************************************** */
/* Section: Included Files                                                    */
/* ************************************************************************** */
/* ************************************************************************** */
#include <xc.h>
#include <plib.h>
#include <stdlib.h>
#include <math.h>
#include <limits.h>
#include "vardef.h"
#include "functions.h"
#include "Uart.h"
#include "NVMem.h"

#ifdef _SUPPORT_LOG
volatile char gnCapTgt = -1;			// lł͉OƂȂ悤ɂ
volatile int  gnCapCount = 0;
volatile DWORD  gnCapLog[1000];
volatile int  gnCap1Mode = 0;
#endif

static  DWORD  PSpans[] = { 420, 410, 300, 300, 300, 300, 300, 300, 300, 300, 190, 180, 420, 410 };


void Delay10us(DWORD dwCount) {
	volatile DWORD _dcnt;

	_dcnt = dwCount * ((DWORD) (0.00001 / (1.0 / GetInstructionClock()) / 10));
	while (_dcnt--) {
#if defined(__C32__)
		Nop();
		Nop();
		Nop();
#endif
	}
}

void DelayMs(WORD ms) {
	unsigned char i;
	while (ms--) {
		i = 4;
		while (i--) {
			Delay10us(25);
		}
	}
}

void ClearVars()
{
	gnanglenow = 12;		// _܂ŁȀɔȂ悤ɂ
	gnTimer2Cnt = 0;
	gidxrpm = 0;
	gnrpm = 0;
	groundtime = 0;
	gIsRunning = 0; // GW~ƂAxJEgiނ܂ł͌vZXLbv
	gOInjOn = 0;
	gOIgnOn = 0;
	gCPlusOn = 0;
	gnKasokuAdd = 0;
	gnInjStopPeriod = 0;
	gnignstoppreiod = 0;
	gnOInjStopPeriod = GetTCntFrom10usec(gsavedata.defInjSpan);
	gnLastBTDC = gsavedata.defBTDCFireVal;
	gnOignstoppreiod = 0;
	gOInjEnter = 0;
	gOIgnEnter = 0;
	gIGNON = 0;
	gINJON = 0;
	gnTimer4Mode = 0;
	gIsInputCycle = -1; 
	gnAccelDelta = 0;
	glastCPTimes[0] = 0;
	glastCPTimes[1] = 0;
	glastCPTimes[2] = 0;
	glastCPTimes[3] = 0;
	glastCPTimes[4] = 0;
	glastCPTimes[5] = 0;
	glastCPTimes[6] = 0;
	glastCPTimes[7] = 0;
	glastCPTimes[8] = 0;
	glastCPTimes[9] = 0;
	glastCPTimes[10] = 0;
	glastCPTimes[11] = 0;
}

void InitVars() {
	
	gnAliveCnt = 0; 
	gidxadresult = 0;
	gValVcc12 = 0; 
	gErrorCode = 0; 
	gValAccel = 0; 
	gValVaccum = 0;
	gnAccelPumpSpan = 0;
	ClearVars();
}
//------------------------------@GW~ۂɂׂ

void EngineStop() {
	CloseTimer2();		
	TMR2 = 0;	
	mINT2IntEnable(0);
	mINT3IntEnable(0);
	IGN_off();
	INJ_off();
	ClearVars();
}

//---------IC4 NNpXMŎg, 
//!		WCLms[ł̃NNpXNote
//!		1]ApX6Aオ藧ƂɔɂKvAeGbWł̌oߎԂŔf
//!		(oߎԁǑoߎԂQ)̎GbW0ƂāA0?11܂ł̃GbWŔf
//!		zCTCNƓ_΃TCN0-23܂ł4TCNƂ
//!		L\̂Ƃanglenow=11-0 ̃^C~O㎀_, 1-2_ƂȂ
//!		anglenow		7    8   9   10  11  0   1    2    3    4    5   6   7   8   9  10  11  0   1   2   3   4   5   6   7   8   9   10  11  0
//!		angle24			19  20  21   22  23  24  1    2    3    4    5   6   7   8   9  10  11  12  13  14  15  16  17  18  19  20  21  22  23  24
//!     v䗦            50  48  32  31  67  64  52  48  51  49           
//!		Zopx			 30  30  19  18  42  41   30  30  30  30  30  30
//!		ۂ̊px	    240 270 300 319 337 19  60    90  120  150  180 210 240 270 300 319 337 379 420 450 480 510 540 570 600  
//!                     <------- zC --->                                 <---_ ----->                           <------- zC ---> 
#define	_CPIDX_BASE		0					// NNpX̋N_ƂCfNX
#define	_CPIDX_CALC		1					// evZs߂̒n_
#define _CPIDX_VACCUMEJUDGE	3				// ̈ʒűzCZT[̒l̑召֌WŋzCTCNA_ΌTCNfł
#define _CPIDX_IGNBASE	9					// _ΐM̋N_ƂȂCfNXABTDC 49t
#define _CPIDX_INJBASE	23					// ːM̏IƂȂt߂̃CfNXB畬ˎԂtZ
#define _CPIDX_INJON	10					// ːMJnƂȂCfNXAATDC 60t
#define _CPIDX_INJNEXT	(_CPIDX_INJON + 1)	// ːM̋N_ƂȂCfNXAATDC 60t
#define _CPDEGREE_BTDC	490					// _ΊJnBTDCpxA0.1xP

void __ISR(_EXTERNAL_4_VECTOR, IPL5SOFT) IC4Interrupt(void)  {
	volatile DWORD curTimer2, curSpan, wkspan;
	static volatile DWORD gnLastCPT2Val, gnLastCPT2span, gnLast2CPT2span, gnLastVaccVal, gnNextBTDC;
	static volatile int gnangle24 = 0;
	
	GetTimer2Val(curTimer2);
	
	gCPlusOn = (mINT4GetEdgeMode() + 1) & 1;
#ifdef _SUPPORT_LOG
	if(gnCapTgt == 0 && gnCapCount < (sizeof(gnCapLog) / sizeof(DWORD))) {
		gnCapLog[gnCapCount++] = ((curTimer2 << 1) | gCPlusOn);
	}
#endif
	
	if (gIsRunning >= _RM_READY) // ~Ԃł͂ȂƂ(ŒłpXłȂƐfłȂ) 
	{
#if 1
		curSpan = GetPassedTimeUL(curTimer2, gnLastCPT2Val);	//@O̕ωԂ獡̌oߎԂ߂B
		gnanglenow++;
		gnangle24++;
		
		// _̔
		if (curSpan  > gnLastCPT2span * 2 /*&& curSpan >= gnLast2CPT2span * 2*/) // ̎ԂO2{ƂA_ł̃pXƔf(index 0))
		{
#if 1			
			gnLastVaccVal = GetADVaccum();
			gnanglenow = 0;		// _Ƃ邾ATDC 140x炢
			gnAliveCnt = 0;		// GW]ƂƂŁAJE^NA

#endif
		} 
		else if(gnanglenow == 1)
		{
			//!!! ŁA݂zCœ_ΑOȂ̂A_ΌŋzCOȂ̂f
			if (gsavedata.isUseVacSensor) 
			{
				gIsInputCycle = gnLastVaccVal - GetADVaccum() > 20; // zCTCN̏ꍇA<OA_΂Ȃ獡񁄑S
			}
			else
			{
				gIsInputCycle = gOIgnEnter & 1 ? 0 : (gIsInputCycle + 1) & 1; //_ΐMŁAǂȂgO
				gOIgnEnter &= ~1;								// 肵NAĂ
			}

			gnangle24 = gIsInputCycle ? 1 : 13;					// 2JE^Zbg
		}

		groundtime = GetPassedTimeUL(curTimer2, glastCPTimes[gnanglenow]); // 1̎
		gnrpm = GetRPMFromTmrVal(groundtime);		// 100]Pʂ̉]

		//else // _ȊȌꍇ
		{
#if 1			
			switch(gnangle24)
			{
				case	_CPIDX_CALC:
				{
					// ̓_΃^C~OƂ̎̕˃^C~Oł߂B
					// ̃^C~OŌ݂̉]mA}bvQƃf[^Ƃ
					
					gidxrpm = gnrpm / 5;	// ݂̉]e[ũCfNX 500rpmP = 0.12b̃JEg
					if (gidxrpm > 23)	gidxrpm = 23;

					// |v
					if (gsavedata.IsUseAccelPump && !gnKasokuAdd && gnAccelDelta > 0) {
						gnKasokuAdd = gnOInjStopPeriod * gecudata.TBL09_data[gnAccelDelta] / 1000;
						gnKasokuSubVal = gnKasokuAdd / gsavedata.nAccelPumpSpan;
						if (gnKasokuSubVal < 1)
							gnKasokuSubVal = 1;
					}

					// ANZlĂ(20 iK))
					int idxAccel = ((GetADAccel() - gsavedata.naccelmin) * 20 / (gsavedata.naccelmax - gsavedata.naccelmin));
					if(idxAccel < 0)	idxAccel = 0;	
					if(idxAccel > 19)	idxAccel = 19;
					
					// ˗ʂ_΂܂ł̎ԂvZ
//					if(gIsInputCycle == 0)
//					{
						int  isLimit = 0, isSkipInj = 0;
						if(!gOInjEnter)
							gnOInjStopPeriod = 0;
						if(gnOInjStopPeriod < guINJDeadtime) 
						{
							// ~b^[
							if (gnrpm > 87 && idxAccel > 2) // IWiłRJbgĂāAANZItȂ
								isLimit = 1;			// R˂JbgAANZȈꍇ~b^[Ɣf
							else
								isSkipInj = 1; 
						}
						if((gsavedata.IsTunnelMode && !isLimit)  ||  gnrpm < _DEF_SWITCH_RPM || isSkipInj)
						{
							gninjststartangle = -1;				// vȂ˂Ȃ悤ɂB
						}
						else
						{
							int nAngles, idxLast, span;
							// 񂪓_ΌA̋zĈ߂̐ݒl쐬
							span = gnOInjStopPeriod;
							if (isLimit)
								span = GetTCntFrom10usec(gsavedata.defInjSpan);
							int ibaseratio = gecudata.TBL02_data[idxAccel][gidxrpm]; // 0.1%P
							gnInjStopPeriod = span * ibaseratio / 1000 + gnKasokuAdd;
							
							// zCoůJĂ^C~O͏㎀_牺_܂ł̊Ԃ120xԂ炢Ȃ̂ŁAJn^C~O𒲐
							//@OtZƂA_+1I_ƂAˎԕ̂ڂpxԍ-1畬ˊJn̂悤ł 
							// xpxɂȂ
							nAngles = gnInjStopPeriod * 3600 / groundtime;
							// 11 - 0 ̒Ԃ炢ɂAˊJnpxZo
							gninjststartangle = 23 - ((nAngles + 290) / 300);	// 37 + 29 = 66 / 30 = 2

							if (gninjststartangle > 22) // ۂɃouJn߂ʒułԂɍȂA
								gninjststartangle = 22;				// ㎀_{75x,@m[}̃AChO炾̂łƂ
						}
						gOInjEnter = 0;					// ŎgpɃNAĂ
//					}
//					else	
//					{
						if(gsavedata.IsTunnelMode  ||  gnrpm < _DEF_SWITCH_RPM )
						{
							gnIgnStartAngle = -1;				// vȂ悤ɂB
							gnIgnStopAngle = -1;
						}
						else
						{
							int  nIgnAngle, nRemain, idxLast;
							// 񂪋zC, _΂܂ł̑ҋ@ԂAgnLastBTDC̊pxɃe[ulĎԂ
							// _ΐM ԌoߌONA95xoߌɃIt悤ɂ
							nIgnAngle = gecudata.TBL03_data[idxAccel][gidxrpm] * 5; // 0.5xPʂ0.1xPʂɂ 
							gnNextBTDC = (gnLastBTDC + nIgnAngle); // _̌oߊpx BTDCł̊pxA0.1xP
							
							gnIgnStopAngle = _CPIDX_IGNBASE;					// ʓdIpx
							// ~Ƃ̃ItZbg͌ŌvZ
	//						gnignstoppreiod = (_CPDEGREE_BTDC -  gnNextBTDC) * groundtime / 3600;		// ʓdI҂
							
							nRemain = nIgnAngle + gnOignstoppreiod * 3600 / groundtime;	// pxZ
							gnIgnStartAngle = (3600 - nRemain) / 300 - 1;	// ㎀_炳̂ڂƁApx̂łP̂Ł[PĂ 
							gnignstartwait = ((3600 - nRemain) % 300) * groundtime / 3600; 
						}
						gOInjEnter &= ~2;
//					}
					gOInjEnter &= ~1;					
				}
					break;
				default:
					break;
			}
			if(gnangle24 == gninjststartangle)
			{
				INJ_on();					// ˊJn^C~O̓VrAłȂ̂ŁAJn͂ōs
				gINJON = 1;
				gnTimer1Mode = 2;			// ˒~܂ł̃^C}Zbg
				OpenTimer1( T1_ON | T1_PS_1_256 | T1_SOURCE_INT, gnInjStopPeriod);
			}
			if(gnangle24 == gnIgnStartAngle)
			{
				if(!gnignstartwait)
				{
					IGN_on();
					gIGNON = 1;
				}
				else
				{
					gnTimer4Mode = 3;			// _ΊJn܂ł̃^C}Zbg
					OpenTimer4( T4_ON | T4_PS_1_256 | T4_SOURCE_INT, gnignstartwait);
				}
			}
			if(gnangle24 == gnIgnStopAngle)
			{
				gnignstoppreiod = (_CPDEGREE_BTDC -  gnNextBTDC) * groundtime / 3600;		// ʓdI҂
				if(!gnignstoppreiod)
				{
					IGN_off();
					gIGNON = 0;
				}
				else
				{
					gnTimer4Mode = 4;			// _ΊJn܂ł̃^C}Zbg
					OpenTimer4( T4_ON | T4_PS_1_256 | T4_SOURCE_INT, gnignstoppreiod);
				}
			}
#endif			
		}

//		gnLast2CPT2span = gnLastCPT2span;		//@pXԊu2Ǘ
		gnLastCPT2span = curSpan;
#endif
	}
	else		// 2_o]ƔfłB
	{
#if 1
		if(gIsRunning == _RM_SWITCHOFF)					// XebvPA
		{
			OpenTimer2( T2_ON | T2_PS_1_256 | T2_SOURCE_INT, WAIT100MS_SYSCLK);	// 0.1bԊuŊ荞ޒx
			mINT2SetEdgeMode(OINJON);		// CWFN^[ONŊ荞
   			mINT3SetEdgeMode(OIGNON);		
			mINT3ClearIntFlag();
			mINT2ClearIntFlag();
			mINT3IntEnable(1);
			mINT2IntEnable(1);
			gnLastCPT2span = 0xffff;
			gnanglenow = 13;				// 肪defaultƂȂ悤ɂĂ		
			gIsRunning++;
		}
		else
		{			// gnanglenow@0->3->0ƃ[v炱̏
			curSpan = GetPassedTimeUL(curTimer2, gnLastCPT2Val);	//@O̕ωԂ獡̌oߎԂ߂B
			gnanglenow++;
			switch(gnanglenow) 
			{
				case 0:
				default:
					if (curSpan  > gnLastCPT2span * 2) // ̎ԂO2{ƂA_ł̃pXƔf(index 0))
					{
						gnLastVaccVal = GetADVaccum();
						gnanglenow = 0;		// _ƂB
						gnangle24 = 0;		// 
					}
					gIsRunning++;
					break;
			}
			gnLastCPT2span = curSpan;
		}
#endif		
	}

    gnLastCPT2Val = curTimer2;
	glastCPTimes[gnanglenow & 0x0f] = curTimer2;
	mINT4IntEnable(0);
	mINT4SetEdgeMode(gCPlusOn);			// ̃GbW𔽓]
	mINT4ClearIntFlag();
	mINT4IntEnable(1);
}

//---------IC1 InjMĎAԊuv̂
//			ONɂȂ=FETʂ̃^C~OLo̓mCYłȂA
//			OFFɂȂ^C~OŃXpCNmCY듮삷\
//!		ANZSȂǁACWFN^[MJbgꍇ̂
//!		ӂ
void __ISR(_EXTERNAL_2_VECTOR, IPL3SOFT) INT2Interrupt(void) {
	static DWORD snLastT2Val = 0;
	DWORD curTimer2, curSpan;
	int	IsInjOn = mINT2GetEdgeMode() == OINJON;

	GetTimer2Val(curTimer2);
	

#ifdef _SUPPORT_LOG
	if(gnCapTgt == 1 && gnCapCount < (sizeof(gnCapLog) / sizeof(DWORD))) {
		gnCapLog[gnCapCount++] = ((curTimer2 << 1) | gOInjOn);
	}
#endif
//	if (gOInjOn == IsInjOn)				
//		goto EXIT;

	curSpan = GetPassedTimeUL(curTimer2, snLastT2Val);
	gOInjOn = IsInjOn;

	if (!gOInjOn) {
		if (gsavedata.IsTunnelMode || gnrpm < _DEF_SWITCH_RPM)
		{
			INJ_off();
			gINJON = 0;
		}
		gnOInjStopPeriod = curSpan;
	} else {
		if (gsavedata.IsTunnelMode || gnrpm < _DEF_SWITCH_RPM)
		{
			INJ_on();
			gINJON = 1;
		}
		gOInjEnter = 3;
	}
	snLastT2Val = curTimer2;
EXIT:	
	mINT2IntEnable(0);
	mINT2SetEdgeMode((gOInjOn + 1) & 1);			// ̃GbW𔽓]
	mINT2ClearIntFlag();
	mINT2IntEnable(1);
}

//---------IC3 COiC^[MĎAԊuv̂
//!		AChOt߂̃COiC^[ONԂ𒲂ׂƂA悻9msʂĂB
//!		120xʂĂ킯ŁA24000]ł12.5msA1msȏ͗]TŊԂ͂ł
void __ISR(_EXTERNAL_3_VECTOR, IPL3SOFT) INT3Interrupt(void) 
{
	static DWORD snLastT2Val = 0;
	DWORD curTimer2, curSpan, dummy;
	char  IsIgnOn;

	IsIgnOn =  (mINT3GetEdgeMode() == OIGNON);
	GetTimer2Val(curTimer2);

#ifdef _SUPPORT_LOG
	if(gnCapTgt == 2 && gnCapCount < (sizeof(gnCapLog) / sizeof(DWORD))) {
		gnCapLog[gnCapCount++] = ((curTimer2 << 1) | IsIgnOn);
	}
#endif
	//!!! tNdŖ{pXɕspXłĂ̂ŁA1msȓ̃pX𖳎
	curSpan = GetPassedTimeUL(curTimer2, snLastT2Val);
//	if(IsIgnOn == gOIgnOn || curSpan < WAIT1MS_SYSCLK * 2)
//		goto EXIT;

	gOIgnOn = IsIgnOn;
	
	if (!gOIgnOn)		// ƂƂ̃COiC^[MONOFFɕς̏
	{
		if (gsavedata.IsTunnelMode || gnrpm < _DEF_SWITCH_RPM)
		{
			gIGNON = 0;
			IGN_off();
		}

		// ʂĂԃJEgZo
		gnOignstoppreiod = curSpan;

		//// BTDC xȂ̂̓NNpX_(0) ōs
		// _(BTDC 18 + 19 + 12 = 49)̌oߊpx
		if(gIsRunning >= _RM_READY)
		{
			curSpan = GetPassedTimeUL(curTimer2, glastCPTimes[_CPIDX_IGNBASE]);	// ۂ̗Loߎ
			gnLastBTDC = _CPDEGREE_BTDC - curSpan * 3600 / groundtime;		// _牽xOœ_΂X^[ĝ߂Ă(1/10xP)
		}
		else
		{
			gnLastBTDC = gsavedata.defBTDCFireVal;
		}
		
	} 
	else	// ƂƂ̃COiC^[MOFFONɕς̏
	{
		// _ΐMANeBJ
		if (gsavedata.IsTunnelMode || gnrpm < _DEF_SWITCH_RPM) 
		{
			IGN_on();
			gIGNON = 1;
		}
		gOIgnEnter = 3;
	}
	snLastT2Val = curTimer2;
EXIT:
	mINT3IntEnable(0);
	mINT3SetEdgeMode((gOIgnOn + 1) & 1);			// ̃GbW𔽓]
	mINT3ClearIntFlag();
	mINT3IntEnable(1);
}

//---------Timer1, Vbg^C}[,R
void __ISR(_TIMER_1_VECTOR, IPL5SOFT) Timer1Interrupt(void) 
{
	mT1ClearIntFlag();
	CloseTimer1();		// ^C}[ItA荞݋֎~
	switch (gnTimer1Mode) {
		case 1: // INJECTER ON
			INJ_on();
			gINJON = 1;
			// CWFN^[~邽߂Ƀ^C}[ċNB
			OpenTimer1( T1_ON | T1_PS_1_256 | T1_SOURCE_INT, gnInjStopPeriod);
			gnTimer4Mode++;
			break;
		case 2: // INJECTER OFF
			gINJON = 0;
			INJ_off();
			break;
	}
	mT1IntEnable(1);
}

//---------Timer4, Vbg^C}[ƂāAR˂Ɠ_΂ŌĂяo
void __ISR(_TIMER_4_VECTOR, IPL5SOFT) Timer4Interrupt(void) 
{
	mT4ClearIntFlag();
	CloseTimer4();		// ^C}[ItA荞݋֎~
	switch (gnTimer4Mode) {
//		case 1: // INJECTER ON
//			INJ_on();
//			gINJON = 1;
//			// CWFN^[~邽߂Ƀ^C}[ċNB
//			OpenTimer4( T4_ON | T4_PS_1_256 | T4_SOURCE_INT, gnInjStopPeriod);
//			gnTimer4Mode++;
//			break;
//		case 2: // INJECTER OFF
//			gINJON = 0;
//			INJ_off();
//			break;
		case 3: // IGNIGHTER ON
			//! NNpXtZČĂяo
			IGN_on();
			gIGNON = 1;
//			OpenTimer4( T4_ON | T4_PS_1_256 | T4_SOURCE_INT, gnignstoppreiod);
//			gnTimer4Mode++;
			break;
		case 4: // IGNIGHTER OFF
			// BTDC ŌĂяo
			IGN_off();
			gIGNON = 0;
			break;
	}
	mT4IntEnable(1);

}

//---------Timer2, 0.1bŊ荞. vWatchDogIȎgŁAGW~ȂǂɎg
//			25632rbgJE^ƁAől27487b, 7Ԍvł
void __ISR(_TIMER_2_VECTOR, IPL6SOFT) Timer2Interrupt(void) {
	mT2ClearIntFlag();
	gnTimer2Cnt += WAIT100MS_SYSCLK; // m32rbg^C}ƓӖɂ
//	gn100msCnt++;
	gnAliveCnt++;
	IncCommCnt();

	if (gnAliveCnt > _DEF_ENGSTOP_100MSCNT && gIsRunning ) 
		EngineStop();

	if ((gnTimer2Cnt & 1) && gsavedata.IsUseAccelPump) {
		if (gnKasokuAdd) {
			gnKasokuAdd -= gnKasokuSubVal;
		} else
			CalcuDelta(); // 0.2bԂł̃ANZψڂŁA|vf
	}
    if (gerror)
          ShowErrorLED(gerror);
}

//!	TvOɎg
void __ISR(_TIMER_3_VECTOR, IPL5SOFT) Timer3Interrupt(void) 
{
//	static int	nCPCnt = 0, nInjCnt = 0, nIgnCnt = 0;
//	static DWORD gnLastIgnOnTVal, gnLastInjOnTVal, gnLastCPT2Val, gnLastCPT2span, gnLast2CPT2span, gnLastVaccVal, gnLast2VaccVal;
//	DWORD	curSpan, curTimer2, wkspan;
//	int		isCPlusOn, isInjOn, isIgnOn;
////
//	GetTimer2Val(curTimer2);
//	// 2̒lŃTvO
//	nCPCnt = ((nCPCnt << 1) | IsOCPulsOn()) & 3;
//	nInjCnt = ((nInjCnt << 1) | IsOINJOn()) & 3;
//	nIgnCnt = ((nIgnCnt << 1) | IsOIGNOn()) & 3;
//	isCPlusOn = (nCPCnt == 3 ? 1 : nCPCnt == 0 ? 0 : gCPlusOn);
//	isInjOn = (nInjCnt == 3 ? 1 : nInjCnt == 0 ? 0 : gOInjOn);
//	isIgnOn = (nIgnCnt == 3 ? 1 : nIgnCnt == 0 ? 0 : gOIgnOn);
//	
//	if(gCPlusOn != isCPlusOn)		// GbW]pX	
//	{
//#if 1
//#endif		
//	}
//	
//	// Q̒lAԔ]Ƃf
//	if (gOInjOn != isInjOn) 
//	{
//#if 1
//#endif		
//	}
//	
//	if(gOIgnOn != isIgnOn)
//	{
//#if 1
//#endif		
//	}
	CloseTimer3();		// ^C}[ItA荞݋֎~
	mT3ClearIntFlag();
	mT3IntEnable(1);

}

//--------- IVXR[vł̂݌ĂяoBADʂi[Ă̂
void __ISR(_TIMER_5_VECTOR, IPL1SOFT) Timer5Interrupt(void) {
	mT5ClearIntFlag();
	if (gScopeTarget & 1)
	{
		gadresult[gidxadresult++] = GetADO2() >> 2;
	}
	if (gScopeTarget & 2)
	{
		gadresult[gidxadresult++] = GetADTemp1() >> 2;
	}
	if (gScopeTarget & 4)
	{
		gadresult[gidxadresult++] = GetADTemp2() >> 2;
	}
	if (gScopeTarget & 8)
	{
		gadresult[gidxadresult++] = GetADVaccum() >> 2;
	}
	if (gScopeTarget & 16)
	{
		gadresult[gidxadresult++] = GetADAccel() >> 2;
	}
	if (gScopeTarget & 32)
	{
		gadresult[gidxadresult++] = IsCPulsOn() ? 0xe0 : 16;
	}
	if (gScopeTarget & 64)
	{
		gadresult[gidxadresult++] = gOInjOn ? 0 : 0xe1; // ON̏ꍇLowAOffȂHIƂ
	}
	if (gScopeTarget & 128)
	{
		gadresult[gidxadresult++] = gOIgnOn ? 0 : 0xe2; // ON̏ꍇLowAOffȂHIƂ
	}
	if (gScopeTarget & 256)
	{
		gadresult[gidxadresult++] = gINJON ? 0xc0 : 0;
	}
	if (gScopeTarget & 512)
	{
		gadresult[gidxadresult++] = gIGNON ?  0xd0 : 0;
	}
	
	if(gidxadresult >= gScopeDataAmount) 
	{
		// ^C}[I
		CloseTimer5();	// 荞݂֎~
		// DMA]Jn
		DmaChnClrEvFlags(DMA_CHANNEL0, DMA_EV_ALL_EVNTS);
		DmaChnSetTxfer(DMA_CHANNEL0, &gadresult[0], (void *)&U2TXREG, gScopeDataAmount, 1, 1);
		mDMA0IntEnable(1);
		DmaChnEnable(DMA_CHANNEL0);
 	}
}

void __ISR(_DMA_0_VECTOR, IPL1SOFT) DMA0Interrupt(void)
{
    // interrupt received from DMA channel
    if (DmaChnGetEvFlags(DMA_CHANNEL0) & DMA_EV_BLOCK_DONE)
    {
        // clear event flag
        DmaChnClrEvFlags(DMA_CHANNEL0, DMA_EV_BLOCK_DONE);
  
        DmaChnDisable(DMA_CHANNEL0);
    }

    if (DmaChnGetEvFlags(DMA_CHANNEL0) & DMA_EV_ERR)
    {
        // clear event flag
        DmaChnClrEvFlags(DMA_CHANNEL0, DMA_EV_ERR);
    }

    // disable interrupt, disable channel and abort transfer
	mDMA0IntEnable(0);
    DmaChnDisable(DMA_CHANNEL0);
    DmaChnAbortTxfer(DMA_CHANNEL0);

    // clear interrupt flag
	mDMA0ClearIntFlag();
}

//---------ADConverter, 0.1mbŊ荞, ADϊʂϐɊi[Ă
//! 荞݂̃I[o[wbh邽߁Al𒀎擾B݌ĂяoȂ
void __ISR(_ADC_VECTOR, IPL1SOFT) ADCInterrupt(void) {
	// AVDD ɂ5V番2.5V̂ƂBZT[̓͂ϓČv̂ƂB
	// ZT̍őŏl200?5K xƐA5K̒R5VցAZT[̐ɕtČvAd͂悻2.50ɕω\
	mAD1ClearIntFlag();
	if (AD1CON2bits.BUFS == 1) 
	{
		gValO2		= ADC1BUF0; // O2
		gValTemp1	= ADC1BUF1; // TEMP1
		gValTemp2	= ADC1BUF2; // TEMP2
		gValVaccum	= ADC1BUF3; // VACCU
		gValAccel	= ADC1BUF4; // ACCEL
		gValVcc12	= ADC1BUF5; // VCC
	}
	else
	{
		gValO2		= ADC1BUF8; // O2
		gValTemp1	= ADC1BUF9; // TEMP1
		gValTemp2	= ADC1BUFA; // TEMP2
		gValVaccum	= ADC1BUFB; // VACCU
		gValAccel	= ADC1BUFC; // ACCEL
		gValVcc12	= ADC1BUFD; // VCC
	}
}

void CalcuDelta() {
	static int lastAccelval = 0;
//	int curAccelval = gadresult[gidxadresult][4]; // ANZlĂ
	int curAccelval = ((GetADAccel() - gsavedata.naccelmin) * 255 / (gsavedata.naccelmax - gsavedata.naccelmin));
	int deltax = curAccelval - lastAccelval;
	if (deltax > 30) {
		deltax = (int) sqrt((double) deltax); // 16iKɕ␳
	} else
		deltax = 0;

	if (!gnKasokuAdd)
		gnAccelDelta = deltax;

	lastAccelval = curAccelval;
}

//--------------------------------------- WkFlush̍XV
#define PAGE_SIZE	1024

void UpdateWkFlush(int IsFlashEnable) {
	FLUSHWK buff;
	int *pflush = (int *) UDATA_WORK_ADDRESS,
			*pwk = (int *) &buff;
	int i;
	// ݂̏ޔĂ	
	for (i = 0; i < (sizeof (FLUSHWK) / sizeof (int)); i++)
		pwk[i] = pflush[i];
	buff.IsFlashEnable = IsFlashEnable;
	//@Yӏ
	NVMemErasePage(pflush); // 1024PʂŏȂ̂ŁA1񂾂ł̍\̕ɂȂ
	//	[hPʂŏ݂Ă
	pflush = (int *) PA_TO_KVA0(UDATA_WORK_ADDRESS);
	for (i = 0; i < (sizeof (FLUSHWK) / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);
}

void UpdateUdata(PSAVEDATA pudata) {
	int *pflush = (int *) UDATA_FLASH_ADDRESS,
			*pwk = (int *) pudata;
	int i, j, ndata, nremain;
	UINT dummy = 0xffffffff;
	//@Yӏ
	for (i = 0; i < (SAVEDATA_SIZE / PAGE_SIZE); i++)
		NVMemErasePage(((void *) pflush) + i * PAGE_SIZE); // 

	ndata = sizeof (SAVEDATA);
	nremain = ndata & 3;
	ndata -= nremain;

	//	[hPʂŏ݂Ă
	pflush = (int *) PA_TO_KVA0(UDATA_FLASH_ADDRESS);
	for (i = 0; i < (ndata / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);

	// 4bytẽoE_0xffŖ߂ď
	if (nremain) {
		for (j = 0; j < nremain; j++)
			((char *) &dummy)[j] = ((char *) pudata)[ndata + j];
		NVMemWriteWord(&pflush[i++], dummy);
	}

	// TCYɑȂOXFF
	dummy = 0xffffffff;
	for (; i < (SAVEDATA_SIZE / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], dummy);

}

void UpdateTable(int idxTbl, PALLTBL ptbldata) {
	int *pflush = (int *) (idxTbl == 0 ? TBL01_FLASH_ADDRESS : TBL01_FLASH_ADDRESS + ALLTBL_SIZE),
			*pwk = (int *) ptbldata;
	int i, j, ndata, nremain;
	UINT dummy = 0xffffffff;
	//@Yӏ
	for (i = 0; i < (ALLTBL_SIZE / PAGE_SIZE); i++)
		NVMemErasePage(((void *) pflush) + i * PAGE_SIZE); // 

	ndata = sizeof (ALLTBL);
	nremain = ndata & 3;
	ndata -= nremain;

	//	[hPʂŏ݂Ă
	pflush = (int *) PA_TO_KVA0(idxTbl == 0 ? TBL01_FLASH_ADDRESS : TBL01_FLASH_ADDRESS + ALLTBL_SIZE);
	for (i = 0; i < (ndata / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);

	// 4bytẽoE_0xffŖ߂ď
	if (nremain) {
		for (j = 0; j < nremain; j++)
			((char *) &dummy)[j] = ((char *) ptbldata)[ndata + j];
		NVMemWriteWord(&pflush[i++], dummy);
	}

	// TCYɑȂOXFF
	dummy = 0xffffffff;
	for (; i < (ALLTBL_SIZE / sizeof (int)); i++)
		NVMemWriteWord(&pflush[i], dummy);

}

void UpdateFlush(void *paddr, size_t size, void *pdata) {
	int i, n;
	int *pflush = (int *) paddr, *pwk = (int *) pdata;

	for (i = 0; i < size; i += PAGE_SIZE)
		NVMemErasePage(paddr + i);
	size = ((size + 3) >> 2) << 2;
	for (i = 0; i < size / sizeof (int); i++)
		NVMemWriteWord(&pflush[i], pwk[i]);
}

//--------------------------------------- 臒l̃CfNX쐬
//! xZT[ADϊl8rbgĂƂāAeɑ΂āA
//!@e[ủԖڂQƂ΂̂Ƃ臒l̃CfNX
//! 0X^[gA臒lȉ̃CfNX臒l悤ɐݒ肷
void RemakeThresholdsIdx() {
	int i, idxLast;
	// 臒le[uCfNX쐬(臒l16iK)
	for (i = 0, idxLast = 255; i < 16; i++) {
		int val = deftable.TBL04_range[i], j; // 
		for (j = val; j < idxLast; j++)
			gIdxTbls[2][j] = (UINT8) i;
		idxLast = val;
	}
	for (i = 0; i < idxLast; i++)
		gIdxTbls[2][i] = 15;
	for (i = 0, idxLast = 255; i < 16; i++) {
		int val = deftable.TBL05_range[i], j; // zCx
		for (j = val; j < idxLast; j++)
			gIdxTbls[3][j] = (UINT8) i;
		idxLast = val;
	}
	for (i = 0; i < idxLast; i++)
		gIdxTbls[3][i] = 15;
}
//--------------------------------------- ʐMC֐

void CommProcess() {
	UINT8 byte;
	UINT8 param[32], buff[2048 + 16], *ptr;
	int i;
	GetChar(&byte);
	switch (byte) {
		case _DC1: // mF(xؒfƁAȃf[^Ă܂̂ŁA̓d2~3񓊂邱Ƃňʒu킹ړI)
			PutChar(_ACK);
			break;
		case 'I': // IDLEJOB
#if 1			
		{
//			int  i;
//			UINT8	*pdst;
//			IDLEDATA gidledata;
//			gidledata.rpm = (UINT8) GetRPMFromTmrVal(groundtime); //  100]Pʂɕ␳
//			gidledata.inject_time = (UINT8) Get100usecFromTmrVal(gnOInjStopPeriod); // 1/10mbPʂɕ␳
//			// ̒l͌vl̂܂ܓn
//			gidledata.o2 = (UINT8)(gValO2 >> 2);		// 
//			gidledata.temp1 = (char) (gIdxTbls[2][(UINT8)(gValTemp1 >> 2)]); // -20 x10xP
//			gidledata.temp2 = (char) (gIdxTbls[3][(UINT8)(gValTemp2 >> 2)]);
//			gidledata.accel = (UINT8)(gValAccel >> 2);
//			gidledata.volt = (UINT8) (gValVcc12 >> 2); // 12V̓d, ő傪15Ƃ 15*̒l/256ŋ߂
//			gidledata.btdcangle = (UINT8) (gnLastBTDC / 10); // pxA
//			gidledata.filler = (UINT8)Get100usecFromTmrVal(gnOignstoppreiod);
//			gidledata.errcode = gErrorCode;
//			pdst = (UINT8 *) & gidledata;
//			for (i = 0; i < 10; i++)
//				PutChar(pdst[i]);
			// œK
			PutChar((UINT8) (GetADVcc12() >> 2)); // 12V̓d, ő傪15Ƃ 15*̒l/256ŋ߂
			PutChar((UINT8) GetRPMFromTmrVal(groundtime)); //  100]Pʂɕ␳
			PutChar((UINT8)(GetADAccel() >> 2));
			PutChar((char) (gIdxTbls[2][(UINT8)(GetADTemp1() >> 2)])); // -20 x10xP
			PutChar((char) (gIdxTbls[3][(UINT8)(GetADTemp2() >> 2)]));
			PutChar((UINT8)(GetADO2() >> 2));		// 
			PutChar(Get100usecFromTmrVal(gnOInjStopPeriod)); // 1/10mbPʂɕ␳
			PutChar((UINT8) ((gnLastBTDC + gsavedata.nTDCOffset) / 5)); // pxA
			PutChar((UINT8)Get100usecFromTmrVal(gnOignstoppreiod));
			PutChar(gErrorCode);
		}
#endif		
			break;
		case 'M':
#if 1
		{
			unsigned char cTblNo, cX, cY, valh, vall;
			short sval;
			if (GetChar(&cTblNo) && GetChar(&cX) && GetChar(&cY) &&
					GetChar(&valh) && GetChar(&vall)) {
				sval = (short) ((unsigned)valh << 8 | vall);
				switch (cTblNo) {
					case 1:
						gecudata.TBL01_data[cY][cX] = sval;
						break;
					case 2:
						gecudata.TBL02_data[cY][cX] = sval;
						break;
					case 3:
						gecudata.TBL03_data[cY][cX] = sval;
						break;
					case 4:
						gecudata.TBL04_data[cY & 0x0f] = sval;
						break;
					case 5:
						gecudata.TBL05_data[cY & 0x0f] = sval;
						break;
					case 6:
						gecudata.TBL06_data[cY & 0x0f] = sval;
						break;
					case 7:
						gecudata.TBL07_data[cY & 0x0f] = sval;
						break;
					case 9:
						gecudata.TBL09_data[cY & 0x0f] = sval;
						break;
					case 11:
						gecudata.TBL01_range[cY & 0x0f] = sval;
						break;
					case 41:
						gecudata.TBL04_range[cY & 0x0f] = sval;
						break;
					case 51:
						gecudata.TBL05_range[cY & 0x0f] = sval;
						break;
				}
				PutChar(_ACK);
			} else
				PutChar(_NAK);
		}
#endif		
			break;
		case 'u': // PGMXV,WKtbV̈̃tOۑăZbg
#if 1
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			PutChar(_ACK);
			DelayMs(10);
			TRANS_LAYER_Close();
			UpdateWkFlush(1);
			DelayMs(10);
			SoftReset();
		}
#endif		
			break;
		case 'U': // MAPt@CۂƃAbv[h
#if 1			
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			for (i = 0;; i++) {
				if (!GetChar(&byte)) {
					PutChar(_NAK);
					return;
				}
				if ((param[i] = byte) == _ETX)
					break;
			}
			param[i] = 0;
			if (param[0] != '0' || !(param[1] == '2' || param[1] == '3')) {
				PutChar(_NAK);
				return;
			}
			PutChar(_ACK);
			ptr = (UINT8*) & gecudata;
			// Pʖ16ioCiɕϊăe[ũAhXɏł
			while (1) {
				int  nget = 0;
				for(nget = 0, byte = 0; nget < _DEF_SEND_BYTE_UNIT && byte != _EOT; nget++)
				{
					if (!GetChar(&byte)) {
						PutChar(_NAK);
						return;
					}
					buff[nget] = byte;
				}
				//EOT͖AKoCgȂ̂ŋɂ
				nget &= (~1);
				hextobin(ptr, &buff[0], nget);
				ptr += (nget / 2);
			}
			ptr = (UINT8*) TBL01_FLASH_ADDRESS + ALLTBL_SIZE * (param[1] == '2' ? 0 : 1);
			UpdateFlush(ptr, sizeof (ALLTBL), &gecudata);
			PutChar(_ACK);
		}
#endif		
			break;
		case 'D': // MAP_E[h
#if 1			
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			for (i = 0;; i++) {
				if (!GetChar(&byte)) {
					PutChar(_NAK);
					return;
				}
				if ((param[i] = byte) == _ETX)
					break;
			}
			param[i] = 0;
			if (param[0] != '0' || !(param[1] == '2' || param[1] == '3')) {
				PutChar(_NAK);
				return;
			}
			PutChar(_ACK);
			ptr = (UINT8*) TBL01_FLASH_ADDRESS + ALLTBL_SIZE * (param[1] == '2' ? 0 : 1);
			for (i = 0; i < ALLTBL_SIZE;) {
				int j;
				int nlen = ALLTBL_SIZE - i > _DEF_SEND_BIN_SIZE ? _DEF_SEND_BIN_SIZE : ALLTBL_SIZE - i;
				bintohex(buff, &ptr[i], nlen);
				for (j = 0; j < _DEF_SEND_BYTE_UNIT; j++)
				{
					PutChar(buff[j]);
				}
				i += nlen;
				if(nlen < _DEF_SEND_BIN_SIZE)
					break;					// f[^̏IӖ̂Ń[vI
				if (!GetChar(&byte)) {		// ẍׂɂĂ݂
					PutChar(_NAK);
					return;
				}
			}
			PutChar(_EOT);
		}
#endif		
			break;
		case 'A':
#if 1			
		{
			//volatile int  remain, remain1, j;
			int		nlayer, nspan;
			UINT8 ulayerl, ulayerh, utime;
			unsigned short ulayer;
			if(!(GetChar(&ulayerl) && GetChar(&ulayerh) && GetChar(&utime)) || (ulayerl == 0 && ulayerh == 0))
			{
				PutChar(_NAK);
				return;
			}
			PutChar(_ACK);
			ulayer = ((ulayerh << 8) & 0xff00) | ulayerl ;
			nlayer = ulayer;
			//!! 8rbg܂ł̃rbg𐔂鉉Z
			nlayer = (nlayer & 0x5555) + (nlayer >> 1 & 0x5555);
			nlayer = (nlayer & 0x3333) + (nlayer >> 2 & 0x3333);
			nlayer = (nlayer & 0x0f0f) + (nlayer >> 4 & 0x0f0f);
 			nlayer = (nlayer & 0x00ff) + (nlayer >> 8 & 0x00ff);
 			
			gScopeTarget = ulayer;
			gidxadresult = 0;
			gScopeDataAmount = nlayer * 1000;
			nspan = WAIT10MS_8DIVCLK * utime / 1000;
			OpenTimer5( T5_ON | T5_PS_1_8 | T5_SOURCE_INT, nspan);	// ͂PVbg^C}[Ȃ̂PR̒l͓sxύX
			mT5SetIntPriority(1);
			mT5ClearIntFlag();
			mT5IntEnable(1);
			
		}
#endif
			break;
		case 'd': // [U[f[^擾
#if 1			
		{
			char *psrc = (char *) &gsavedata;
			PutChar(_ACK);
			for (i = 0; i < sizeof (SAVEDATA);) {
				int j, nlen = sizeof (SAVEDATA) - i > 128 ? 128 : sizeof (SAVEDATA) - i;
				bintohex(buff, &psrc[i], nlen);
				for (j = 0; j < nlen * 2; j++)
					PutChar(buff[j]);
				i += nlen;
			}
			PutChar(_EOT);

		}
#endif		
			break;
		case 'c': //@[U[f[^ݒ
#if 1			
		{
			char *psrc = (char *) &gsavedata;
			PutChar(_ACK);
			i = 0;
			while (1) { 
				if (!GetChar(&byte)) {
					PutChar(_NAK);
					return;
				}
				if ((buff[i] = byte) == _EOT)
					break;
				i++;
				if (i >= 256) {
					hextobin(psrc, &buff[0], 256);
					psrc += 128;
					i = 0;
				}
			}
			i &= ~1;
			if (i > 0)
				hextobin(psrc, &buff[0], i);

			UpdateUdata(&gsavedata);
			PutChar(_ACK);
			guINJDeadtime = GetTCntFrom10usec(gsavedata.nInjDeadTime);
		}
#endif		
			break;
		case 'm':
#if 1
		{
			unsigned char cTblNo, cX, cY, valh, vall;
			short sval;
			if (GetChar(&cTblNo) && GetChar(&cX) && GetChar(&cY)) {
				switch (cTblNo) {
					case 1:
						sval = gecudata.TBL01_data[cX][cY];
						break;
					case 2:
						sval = gecudata.TBL02_data[cX][cY];
						break;
					case 3:
						sval = gecudata.TBL03_data[cX][cY];
						break;
					case 4:
						sval = gecudata.TBL04_data[cX & 0x0f];
						break;
					case 5:
						sval = gecudata.TBL05_data[cX & 0x0f];
						break;
					case 6:
						sval = gecudata.TBL06_data[cX & 0x0f];
						break;
					case 7:
						sval = gecudata.TBL07_data[cX & 0x0f];
						break;
					case 9:
						sval = gecudata.TBL09_data[cX & 0x0f];
						break;
					case 11:
						sval = gecudata.TBL01_range[cX & 0x0f];
						break;
					case 41:
						sval = gecudata.TBL04_range[cX & 0x0f];
						break;
					case 51:
						sval = gecudata.TBL05_range[cX & 0x0f];
						break;
				}
				PutChar(_ACK);
				PutChar((sval >> 8) & 0xff);
				PutChar(sval && 0xff);
			} else
				PutChar(_NAK);
		}
#endif		
			break;
		case 'S': // e[utbV֏
#if 1
		{
			char tblno;
			GetChar(&tblno);
			if (tblno > 2) tblno -= 0x30;
			tblno -= 1;
			UpdateTable(tblno == 0 ? 0 : 1, &gecudata);
			PutChar(_ACK);
		}
#endif		
			break;
		case 't':
#if 1
		{
			unsigned char cTblNo;
			int nsizel;
			char *ptbl, *pnum;
			if (GetChar(&cTblNo) ) {
				switch (cTblNo) {
					case 1:
						ptbl = (char *)&gecudata.TBL01_data[0][0];
						nsizel = sizeof(gecudata.TBL01_data);
						break;
					case 2:
						ptbl = (char *)&gecudata.TBL02_data[0][0];
						nsizel = sizeof(gecudata.TBL02_data);
						break;
					case 3:
						ptbl = (char *)&gecudata.TBL03_data[0][0];
						nsizel = sizeof(gecudata.TBL03_data);
						break;
					case 4:
						ptbl = (char *)&gecudata.TBL04_data[0];
						nsizel = sizeof(gecudata.TBL04_data);
						break;
					case 5:
						ptbl = (char *)&gecudata.TBL05_data[0];
						nsizel = sizeof(gecudata.TBL05_data);
						break;
					case 6:
						ptbl = (char *)&gecudata.TBL06_data[0];
						nsizel = sizeof(gecudata.TBL06_data);
						break;
					case 7:
						ptbl = (char *)&gecudata.TBL07_data[0];
						nsizel = sizeof(gecudata.TBL07_data);
						break;
					case 9:
						ptbl = (char *)&gecudata.TBL09_data[0];
						nsizel = sizeof(gecudata.TBL09_data);
						break;
					case 11:
						ptbl = (char *)&gecudata.TBL01_range[0];
						nsizel = sizeof(gecudata.TBL01_range);
						break;
					case 41:
						ptbl = (char *)&gecudata.TBL04_range[0];
						nsizel = sizeof(gecudata.TBL04_range);
						break;
					case 51:
						ptbl = (char *)&gecudata.TBL05_range[0];
						nsizel = sizeof(gecudata.TBL05_range);
						break;
				}
				
				PutChar(_ACK);
				pnum = (char *)&nsizel;		// TCYM
				bintohex(buff, ptbl, nsizel);
				nsizel *= 2;
				for(i = 0; i < nsizel; i++) 
				{
					PutChar(buff[i]);
					//PutChar(0xfe);
				}
				PutChar(_EOT);
			} else
				PutChar(_NAK);
		}
#endif		
			break;
		case 'a': // Xbgŏl
#if 1
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			gsavedata.naccelmin = GetADAccel();
			UpdateUdata(&gsavedata);
			PutChar(_ACK);
		}
		break;
#endif		
		case 'b': // Xbgől
#if 1
		{
			if (gIsRunning) // ss
			{
				PutChar(_NAK);
				break;
			}
			gsavedata.naccelmax = GetADAccel();
			UpdateUdata(&gsavedata);
			PutChar(_ACK);
		}
		break;
#endif		
		case 'f': // Xbgl
#if 1
		{
			PutChar((UINT8)((GetADAccel() >> 8) & 0xff));
			PutChar((UINT8)(GetADAccel() & 0xff));
		}
			break;
#endif		
		case 'x':	// eXgp, x̌2oCgŋ̓IȃeXgeƂ
#if 1
		{
			UINT8  cmd1, cmd2;
			if (GetChar(&cmd1) && GetChar(&cmd2)) 
			{
				if(cmd1 == 'E')
				{
					gerror = cmd2 == '1' ? gnAliveCnt : gIsRunning;
					PutChar(_ACK);
					return;
				}
				if (gIsRunning) // ss
				{
					PutChar(_NAK);
					break;
				}
				cmd2 -= 0x30;

				if(cmd1 == 'F')		// fet ̃`FbN
				{
					if(cmd2 & 1)
						IGN_on();
					else
						IGN_off();
					if(cmd2 & 2)
						INJ_on();
					else
						INJ_off();
				}
				else if (cmd1 == 'L')
				{
					if(cmd2)	led1_on();
					else		led1_off();
				}
#ifdef _SUPPORT_LOG
				else if(cmd1 == '1')
				{
					if(cmd2 > 6)	{
						int  i;
						gnCapTgt = cmd2 - 7;
						for(i = 0; i < sizeof(gnCapLog) / sizeof(DWORD); i++)
							gnCapLog[i] = 0;
						gnCapCount = 0;
					}
					else
						gnCap1Mode = cmd2;
				}
#endif				
				else if (cmd1 == 'f')
				{
					if(cmd2 == 1) {
						// 荞ݏ֎~
						mINT4ClearIntFlag();
						mINT4IntEnable(0);
						mINT3IntEnable(0);
						mINT2IntEnable(0);
						// |[OɈڍs
						mT3SetIntPriority(5);
						mT3ClearIntFlag();
						mT3IntEnable(1);
						OpenTimer3( T3_ON | T3_PS_1_8 | T3_SOURCE_INT, WAIT10NS_8DIVCLK);	
					}
					else {
						// |[O𒆎~
						CloseTimer3();

						//@荞ݏċN
						mINT4ClearIntFlag();
						mINT4IntEnable(1);
					    mINT2SetEdgeMode(OINJON);		// CWFN^[ONŊ荞
						mINT3SetEdgeMode(OIGNON);		
						mINT3ClearIntFlag();
						mINT2ClearIntFlag();
						mINT3IntEnable(1);
						mINT2IntEnable(1);

					}
				}
			}
			PutChar(_ACK);
		}
#endif
			break;
#ifdef _SUPPORT_LOG
		case 'h':	
		{
			PutChar(_ACK);
			// DMA]Jn
			DmaChnClrEvFlags(DMA_CHANNEL0, DMA_EV_ALL_EVNTS);
			DmaChnSetTxfer(DMA_CHANNEL0, (void *)&gnCapLog[0], (void *)&U2TXREG, sizeof(gnCapLog), 1, 1);
			mDMA0IntEnable(1);
			DmaChnEnable(DMA_CHANNEL0);
		}
			break;
#endif		
		default:
			PutChar(_NAK);
			break;
	}

}

void hextobin(void *pdest, char *psrc, int nlen) {
	int i;
	char b1, b2;
	nlen = (nlen & ~1);
	for (i = 0; i < nlen; i += 2) {
		b1 = psrc[i] - 0x30;
		if (b1 > 9) b1 -= 7;
		b2 = psrc[i + 1] - 0x30;
		if (b2 > 9) b2 -= 7;
		((char *) pdest)[i >> 1] = (b1 << 4) | b2;
	}
}

void bintohex(char *pdest, void *psrc, int nlen) {
	int i, j;
	unsigned char b1, b2;
	nlen = (nlen & ~1);
	for (i = 0, j = 0; i < nlen; i++) {
		b1 = (((char*) psrc)[i] >> 4) & 0x0f;
		b2 = ((char*) psrc)[i] & 0x0f;
		pdest[j++] = (char) (b1 > 9 ? b1 + 0x37 : b1 + 0x30);
		pdest[j++] = (char) (b2 > 9 ? b2 + 0x37 : b2 + 0x30);
	}
}

//-------------------------------------------------------------------
//  G[R[hɑΉLED_ł郋[`
//	TSPAN_MY1SCOUNT1b̃[vƂĕ\
//	100̌0.25bA10̌0.5bA1̌1bɓ_ł悤ɂȂ
//  15Ȃ Z_1A_5
//-------------------------------------------------------------------
void ShowErrorLED(int nError)
{
#define __LEDON()	led1_on()
#define __LEDOFF()	led1_off()
#define TSPAN_MY1SCOUNT  8
#define TSPAN_2DIV 4
#define TSPAN_4DIV 2
#define TSPAN_8DIV 1
#define TSPAN_1DIV 8
	// 3f = 1s, 1f = 0.5s, f = 0.25s
    static  int savError = 0, nextError = 0;
    static  char    k100 = 0, k10 = 0, k1 = 0, bRepat = 0,  bOn = 0;
    static  int     nCnt = 0, kwait = 0;
    
//    if(!nError)
//    {
//        if(nError != savError)
//            __LEDOFF();
//        return;
//    }
    if(nextError != savError || bRepat)
    {
        savError = nextError;
        __LEDOFF();
        nCnt = 0;
		bOn = 0;
        bRepat = 0;
        k100 = (char)(nError / 100);
        k10 = (char)((nError - (k100 * 100) ) / 10);
        k1 = nError % 10;
        kwait = TSPAN_MY1SCOUNT * 2;
    }
    nCnt++;
    if(k100)
    {
        if((nCnt % TSPAN_4DIV) <= TSPAN_8DIV)
            __LEDOFF();
        else
            __LEDON();
        if(!(nCnt % TSPAN_4DIV))
		{
			nCnt = 0;
            k100--;
		}
        return;
    }
    if(k10)
    {
        if((nCnt % TSPAN_2DIV) <= TSPAN_4DIV)
            __LEDOFF();
        else
            __LEDON();
        if(!(nCnt % TSPAN_2DIV))
		{
			nCnt = 0;
            k10--;
		}
        return;
    }
    
    if(k1)
    {
		if(!bOn)
		{
			__LEDOFF();
		}
		else
		{
			__LEDON();
		}
		if((nCnt % TSPAN_1DIV) == 0)
		{
			bOn = (bOn + 1) & 1;
			if(!bOn)
				 k1--;
		}
        return;
    }
    
    if(kwait)
    {
       __LEDOFF();
       kwait --;
    }
    
    if (kwait < 1)
    {
		nextError = nError;				// \Ƃ܂
        bRepat = 1;
    }
}

/* *****************************************************************************
 End of File
 */

void encodeb64( char *lpszDest, char *lpszOrg, int nlen)
{
	static const  char base64_enc_map[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

	int i = 0, iR = 0;

    while(nlen)
	{
        lpszDest[iR] = base64_enc_map[(lpszOrg[i]) >> 2];
        if (nlen == 1) {
            lpszDest[iR + 1] = base64_enc_map[((lpszOrg[i] & 0x3) << 4) ];
            lpszDest[iR + 2] = '=';
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 1] = base64_enc_map[((lpszOrg[i] & 0x3) << 4) + ((lpszOrg[i + 1]) >> 4)];
        if (nlen == 2) {
            lpszDest[iR + 2] = base64_enc_map[(lpszOrg[i + 1] & 0xf) << 2];
            lpszDest[iR + 3] = '=';
            lpszDest[iR + 4] = '\0';
            break;
        }
        lpszDest[iR + 2] = base64_enc_map[((lpszOrg[i + 1] & 0xf) << 2) + ((lpszOrg[i + 2]) >> 6)];
        lpszDest[iR + 3] = base64_enc_map[lpszOrg[i + 2] & 0x3f];
        lpszDest[iR + 4] = '\0';
		nlen -= 3;
        i += 3;
        iR += 4;
    }
    return;
}

int  decodeb64(char *lpszResult, char *lpszStr)
{
	static const  char base64_dec_map[128] =
	{
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127, 127, 127, 127, 127, 127, 127, 127,
		127, 127, 127,  62, 127, 127, 127,  63,  52,  53,
		 54,  55,  56,  57,  58,  59,  60,  61, 127, 127,
		127,  64, 127, 127, 127,   0,   1,   2,   3,   4,
		  5,   6,   7,   8,   9,  10,  11,  12,  13,  14,
		 15,  16,  17,  18,  19,  20,  21,  22,  23,  24,
		 25, 127, 127, 127, 127, 127, 127,  26,  27,  28,
		 29,  30,  31,  32,  33,  34,  35,  36,  37,  38,
		 39,  40,  41,  42,  43,  44,  45,  46,  47,  48,
		 49,  50,  51, 127, 127, 127, 127, 127
	};
	int len, i, iR;
    char a1, a2, a3, a4;

    len = strlen(lpszStr);
    i = 0;
    iR = 0;
    while (i < len) {
        a1 = base64_dec_map[lpszStr[i++]];
        a2 = base64_dec_map[lpszStr[i++]];
        lpszResult[iR++] = (a1 << 2) + (a2 >>4);
		if(lpszStr[i] == '=')
			return iR;
        a3 = base64_dec_map[lpszStr[i++]];
        lpszResult[iR++] = (a2 << 4) + (a3 >>2);
		if(lpszStr[i] == '=')
			return iR;
        a4 = base64_dec_map[lpszStr[i++]];
        lpszResult[iR++] = (a3 << 6) + a4;
    }
    return iR;
}

