/* ************************************************************************** */
/** Descriptive File Name

  @Company
    Company Name

  @File Name
    filename.h

  @Summary
    Brief description of the file.

  @Description
    Describe the purpose of this file.
 */
/* ************************************************************************** */
#include <xc.h>
//#include <plib.h>

#ifndef _VARDEF_H    /* Guard against multiple inclusion */
#define _VARDEF_H


/* ************************************************************************** */
/* ************************************************************************** */
/* Section: Included Files                                                    */
/* ************************************************************************** */
/* ************************************************************************** */

/* This section lists the other files that are included in this file.
 */

/* TODO:  Include other files here if needed. */


/* Provide C++ Compatibility */
#ifdef __cplusplus
extern "C" {
#endif

//---------- EύX邽߂̒`
//#define	__DEBUG
//#define _SUPPORT_LOG	1
//---------- n[hEFAˑ̒`   
    
#define SYS_FREQ (40000000L)
#define GetSystemClock()    (SYS_FREQ)
#define GetInstructionClock()       GetSystemClock()
#define BlinkLED() (LATBbits.LATB7 = (PORTBbits.RB7 != 1))
#define led1_on()	(LATBbits.LATB7 = 0)
#define led1_off()	(LATBbits.LATB7 = 1)
#define InitLED() do{TRISBbits.TRISB7 = 0; led1_off();}while(0)

#define CPulsPort	(PORTBbits.RB4)    
#define IsOCPulsOn()  (CPulsPort == 1)	// NNpXオ蒆
#define OINJON		1					// OXXXX IWiINJMONɂȂƂ̃|[gl
#define OINJOFF		0
#define INJON		0					// {Hł̏oFETONƂȂƂ̃|[gl
#define INJOFF		1
#define INJ_on()    (LATBbits.LATB9 = INJON)
#define INJ_off()    (LATBbits.LATB9 = INJOFF)
#define INJ_setup() do{TRISBbits.TRISB9 = 0; INJ_off();}while(0)  
#define OINJPort	(PORTAbits.RA4)
#define IsOINJOn()	(OINJPort == OINJON)

#define OIGNON		1
#define OIGNOFF		0	
#define IGNON		0
#define IGNOFF		1	
#define IGN_on()    (LATBbits.LATB8 = IGNON)
#define IGN_off()    (LATBbits.LATB8 = IGNOFF)
#define IGN_setup() do{TRISBbits.TRISB8 = 0; IGN_off(); }while(0)  
#define OIGNPort	(PORTBbits.RB5)
#define IsOIGNOn()	(OIGNPort == OIGNON)
    
#define MTR1_setup()    do{TRISBbits.TRISB13 = 0; LATBbits.TRISB13= 0;}while(0)  
#define MTR2_setup()    do{TRISBbits.TRISB12 = 0; LATBbits.TRISB12= 0;}while(0)  
#define MTR1_LO()   ( LATBbits.LATB13= 0)
#define MTR1_HI()   ( LATBbits.LATB13= 1)
#define MTR2_LO()   ( LATBbits.LATB10= 0)
#define MTR2_HI()   ( LATBbits.LATB10= 1)
#define GetADO2()		(ADC1BUF0)
#define GetADTemp1()	(ADC1BUF1)
#define GetADTemp2()	(ADC1BUF2)
#define GetADVaccum()	(ADC1BUF3)
#define GetADAccel()	(ADC1BUF4)
#define GetADVcc12()	(ADC1BUF5)

#define UDATA_FLASH_ADDRESS         0x9D004000      // ̃vOŎgpłtbV̈̐擪
#define UDATA_WORK_ADDRESS			(UDATA_FLASH_ADDRESS + 0x0400)
#define TBL01_FLASH_ADDRESS         (UDATA_WORK_ADDRESS + 0x400)        // 
#define UDATA_WORK_SIZE				(sizeof(FLUSHWK))
    
#define UDATA_FLASH_END_ADDRESS   (0x9D004000 + 0x2000)

#define TMR_PRESCL  256         // ^C}[256    
#define WAIT100MS_SYSCLK	(SYS_FREQ/TMR_PRESCL/10)		// 0.1b̃^C}JEgl, 0x3d08  
#define WAIT100US_SYSCLK	(SYS_FREQ/TMR_PRESCL/10000)		// 0.1~b̃^C}JEgl, 15  
#define WAIT1MS_SYSCLK		(SYS_FREQ/TMR_PRESCL/1000)		// 1~b̃^C}JEgl, 156  
#define WAIT10MS_SYSCLK		(SYS_FREQ/TMR_PRESCL/100)		// 10~b̃^C}JEgl, 1562  
#define WAIT10MS_8DIVCLK	(SYS_FREQ/800)
#define WAIT10NS_8DIVCLK	(SYS_FREQ/800000)				// 0.01 b̂W^C}JEgl 50
#define WAIT20NS_8DIVCLK	(SYS_FREQ/400000)				// 0.02 b̂W^C}JEgl 100
#define WAIT50NS_8DIVCLK	(SYS_FREQ/160000)				// 0.05 b̂W^C}JEgl 250
//#define Get10usecFromTmrVal(a)  (SYS_FREQ / 100000 * a /TMR_PRESCL)  // ̃JE^l1/100~bPʂł
#define Get10usecFromTmrVal(a)  (a * 10000 / WAIT100MS_SYSCLK)  // ̃JE^l1/100~bPʂł
#define Get100usecFromTmrVal(a)  (a * 1000 / WAIT100MS_SYSCLK)  // ̃JE^l1/10~bPʂł
#define GetTCntFrom10usec(a)    (a * WAIT100MS_SYSCLK / 10000)  // 1/100~bJE^lł
#define MINCOUNTMAXP100()       (SYS_FREQ/TMR_PRESCL*6/10)
#define GetRPMFromTmrVal(a)     (!a ? 0 : MINCOUNTMAXP100() / a) // ꕪ̑^C}JEg/100/1]̃JEg
#define EnableTimer2Int()		(IEC0SET = _IEC0_T2IE_MASK)
#define DisableTimer2Int()		(IEC0CLR = _IEC0_T2IE_MASK)
#define GetTimer2Val(a)		{ DisableTimer2Int(); a = TMR2 + gnTimer2Cnt; EnableTimer2Int(); }
//#define DEFIGN_DEADTIME		(200)							// COiC^[̃fbh^Cdefaultl1/100~bP
#define DEFINJ_DEADTIME		(90)							// COiC^[̃fbh^Cdefaultl1/100~bP
//---------- \̂Ȃ    

//---------- ECUe[u`   
//          TuRƂĎgp̂TBL02TBL03̂݁B]ƃXbgł̕ˑʌWA܂͐ipvXl
    
#define ALLTBL_SIZE       3072       // 3K,@`ĂȂfillerƂ
typedef struct _ALLTBL
{
    short TBL01_data[16][24];       // Vaccum x RPM table
    short TBL01_range[16];          // Vaccum 臒l
    short TBL02_data[20][24];       // Accel x RPM table, 0.1%P
 //   short TBL02_range[16];          // Accel 臒l
    char  TBL03_data[20][24];       // Accel x RPM table, ip@vX}CiX0.5xP
    short TBL04_data[16];           // Water Temp
    short TBL04_range[16];          // Temp 臒l
    short TBL05_data[16];           // Air Temp
    short TBL05_range[16];          // Temp 臒l
    short TBL06_data[16];           // O2 table
    short TBL07_data[16];           // VOLTAGE
    short TBL09_data[16];           // Accel Pump   , 0.1%P
    //<--- to 1440 byte to here
    struct _TBL08{
        char    password[16];
        char    filler[384];
    } TBL08;
}ALLTBL, *PALLTBL;

//------------------------------------ [U[f[^ƂāAFLUSHɕۑf[^
#define SAVEDATA_SIZE       1024        // 1K,@`ĂȂfillerƂ
typedef  struct  _SAVEDATA {
    int verifysign1;                    // ǂpɎgpA0xffffffff Ȃ疢
    int ncurrent;                       // ݂̃e[uԍAftHg0Ƃ(0 or 1)
    int naccelmin;                      // ANZZT[̓dŏl
    int naccelmax;                      // ANZZT[̓dől
    int verifysign2;                    // ǂpɎgpA0xffffffff Ȃ疢
    int defBTDCFireVal;                 // ftHg̐ipxA0.1xPʁBftHg 200ɂ邩
    int defInjSpan;                     // ftHg̕ˎԁA1/100~bP ftHg 400
    int defIgnSpan;                     // ftHgIGNʓdԁA1/100~bP ftHg 640
    int IsUseAccelPump;                 // |v@\AftHgIt
    int nAccelPumpSpan;                 // |vʎԁA0.1bP, ftHg30
    int IsTunnelMode;                   // gl[hBM̂܂܍ČāAm[}Ɠɂ
	int isUseVacSensor;					// zCƓ_΂̃TCNɋzCZTgp邩ǂ
	int filler0;							// COiC^[̖
	int nInjDeadTime;					// CWFN^[̖
	int nTDCOffset;						// ㎀_t߂ƎvNNpX̃ItZbgpx.0.1xPʁB
}SAVEDATA, *PSAVEDATA;

//-------------- u[g[_Ɩ{̂ŏ񋤗Lׂ̈ɕێtbV̈̃f[^\
typedef struct _FLUSHWK
{
	int		IsFlashEnable;
	//---->	Add Here
	//<----
	UINT8	filler[0x400 - sizeof(int)];	// S1KoCgł
}FLUSHWK, *PFLUSHWK;

typedef struct _IDLEDATA {
    unsigned char volt;         // d
    unsigned char rpm;          //]
    unsigned char accel;        //ANZ
    char temp1;                 //TEMP1
    char temp2;                 //TEMP2
    unsigned char o2;           //O2
    unsigned char inject_time;  //ˎ
    unsigned char btdcangle;    //ipx
    unsigned char filler;       //
    unsigned char errcode;      //G[R[h
}IDLEDATA , *PIDLEDATA;

//-----------------------------------------------@萔AENUM
enum    enErrorCode { EC_NOERROR = 0, EC_VOLTAGELO, EC_NOCOM  };
#define _DEF_ENGSTOP_100MSCNT   5       // ̐l100~b̊ԁApXȂ΃GW~
//#define _DEF_START_JUDGE_PULSCNT    14   // ̉񐔂̃pXΉ]JnƔf
#define _RM_SWITCHOFF			0
#define _RM_SWITCHON			1
#define _RM_FOUND_P0			2
#define _RM_READY				3
#define _DEF_SWITCH_RPM			15           //  1500 ]Ő؂ւ
//#define _DEF_SWITCH_RPM		0           // [ɂ邱ƂŁA̋@\𖳌ɂł
#define _DEF_SEND_BYTE_UNIT     256     // xɓdMłTCY(16ix[X)
#define _DEF_SEND_BIN_SIZE      (_DEF_SEND_BYTE_UNIT / 2)   // oCix[XœdMł(16i1oCgɑ΂2ɂȂ̂ŔƂȂ))
	//---------- ʕϐ`   
extern volatile char gIsRunning;
extern volatile int gnAliveCnt;		// 0.1bŉZANNpX_m0NAŉ]Ɏg
extern volatile DWORD gnTimer2Cnt;	// Timer2荞݂Ƃ̃JEg,0.1b
extern volatile int gn100msCnt;
extern volatile int gnTimer1Mode;
extern volatile int gnTimer4Mode;
extern volatile int gnInjStopPeriod;
extern volatile int gninjststartwait;
extern volatile int gninjststartangle;
extern volatile int gnIgnStartAngle;
extern volatile int gnIgnStopAngle;
extern volatile int gnignstoppreiod;
extern volatile int gnignstartwait;
extern unsigned char gadresult[4000];
extern volatile int gidxadresult;
extern volatile int groundtime;		// 1]̃^C}[l
extern volatile DWORD glastCPTimes[32];
extern volatile int gIsInputCycle;	// ݂zCTCNǂ
extern volatile int gidxrpm;
extern volatile int gnrpm;			// ](100]P)
extern volatile int gnanglenow;		// NNpX݈̌ʒuA30xPʂ
extern volatile int gCPlusOn;		// ݁ANNpX
extern volatile int gOInjOn;		// ݁AIWiCWFN^[ON̏ꍇP
extern volatile int gnOInjStopPeriod; // IWiCWFN^ ON->OFF܂ł̃^C
extern volatile int gOIgnOn;		// ݁AIWiIGNON̏ꍇ1
extern volatile int gnOignstoppreiod; // IWiIGN ON->OFF܂ł̃^C
//extern volatile int gADOkayBank;	// ADϊĂoN 1 or 2, 0ȂAD,  rbgZ4 Ȃ΃oNPbN, 8Ȃ2bN
extern volatile char gOInjEnter;	// IWiCWFN^[2]ONɂȂƂ邩
extern volatile char gOIgnEnter;	// IWiIGN2]ONɂȂƂ邩
#define IsCPulsOn()  (gCPlusOn)		// NNpXオ蒆
extern volatile int gErrorCode;		// O[oG[R[h
extern ALLTBL gecudata;
extern UINT8 gIdxTbls[4][256];		// 臒l8rbgȂ̂ŁAYɕϊł悤e[u
extern volatile int gValVcc12;		// 12VdĎp
extern volatile int gValAccel;		// 255 - min
extern volatile int gValVaccum;
extern volatile int gValO2;
extern volatile int gValTemp1;
extern volatile int gValTemp2;
extern volatile int gScopeTarget;	// IVXR[v̑Ώۃf[^rbgtOőI
extern volatile int gScopeDataAmount;
extern volatile int gnLastBTDC;		// BTDC_ΊpxA0.1xP
extern volatile int gnAccelDelta;
extern volatile int gnKasokuAdd;	// ɒǉ鑝ʁB{lɑ΂p[Ze[WA0.1%P
extern volatile int gnKasokuSubVal; // gnKasokuAdd 0.1bɌZl
extern volatile int gnAccelPumpSpan;
extern volatile int gIGNON;
extern volatile int gINJON;
extern volatile DWORD  guINJDeadtime;

extern SAVEDATA gsavedata; //  
extern ALLTBL deftable;

extern volatile int gerror;

#define    SetErrorCode( nError)     (gerror = nError)
void ShowErrorLED(int nError);
#define ClearErrorCode()	(gerror = 0)	

    /* Provide C++ Compatibility */
//!!!XC32̃oO΍
#undef mAD1ClearIntFlag
 #define mAD1ClearIntFlag()                  (IFS0CLR = _IFS0_AD1IF_MASK )
   
#ifdef __cplusplus
}
#endif

#endif /* _VARDEF_H */

